# REST Resource: targetVpnGateways

- [Resource: TargetVpnGateway](https://docs.cloud.google.com/compute/docs/reference/rest/v1/targetVpnGateways#TargetVpnGateway)
  - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/targetVpnGateways#TargetVpnGateway.SCHEMA_REPRESENTATION)
- [Methods](https://docs.cloud.google.com/compute/docs/reference/rest/v1/targetVpnGateways#METHODS_SUMMARY)

## Resource: TargetVpnGateway

Represents a Target VPN Gateway resource.

The target VPN gateway resource represents a Classic Cloud VPN gateway. For more information, read the [the Cloud VPN Overview](https://cloud.google.com/network-connectivity/docs/vpn/concepts/overview).

| JSON representation |
|---|
| ``` { "kind": string, "id": string, "creationTimestamp": string, "name": string, "description": string, "region": string, "network": string, "tunnels": [ string ], "status": enum, "selfLink": string, "forwardingRules": [ string ], "labels": { string: string, ... }, "labelFingerprint": string, "params": { "resourceManagerTags": { string: string, ... } } } ``` |

| Fields ||
|---|---|
| `kind` | `string` Output only. Type of resource. Always `compute#targetVpnGateway` for target VPN gateways. |
| `id` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. The unique identifier for the resource. This identifier is defined by the server. |
| `creationTimestamp` | `string` Output only. Creation timestamp in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. |
| `name` | `string` Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters long, and comply with [RFC1035](https://www.ietf.org/rfc/rfc1035.txt). Specifically, the name must be 1-63 characters long and match the regular expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash. |
| `description` | `string` An optional description of this resource. Provide this property when you create the resource. |
| `region` | `string` Output only. URL of the region where the target VPN gateway resides. You must specify this field as part of the HTTP request URL. It is not settable as a field in the request body. |
| `network` | `string` URL of the network to which this VPN gateway is attached. Provided by the client when the VPN gateway is created. |
| `tunnels[]` | `string` Output only. A list of URLs to VpnTunnel resources. VpnTunnels are created using the `compute.vpntunnels.insert` method and associated with a VPN gateway. |
| `status` | `enum` Output only. The status of the VPN gateway, which can be one of the following: CREATING, READY, FAILED, or DELETING. |
| `selfLink` | `string` Output only. Server-defined URL for the resource. |
| `forwardingRules[]` | `string` Output only. A list of URLs to the ForwardingRule resources. ForwardingRules are created using `compute.forwardingRules.insert` and associated with a VPN gateway. |
| `labels` | `map (key: string, value: string)` Labels for this resource. These can only be added or modified by the `setLabels` method. Each label key/value pair must comply with [RFC1035](https://www.ietf.org/rfc/rfc1035.txt). Label values may be empty. |
| `labelFingerprint` | `string (https://developers.google.com/discovery/v1/type-format format)` A fingerprint for the labels being applied to this TargetVpnGateway, which is essentially a hash of the labels set used for optimistic locking. The fingerprint is initially generated by Compute Engine and changes after every request to modify or update labels. You must always provide an up-to-date fingerprint hash in order to update or change labels, otherwise the request will fail with error `412 conditionNotMet`. To see the latest fingerprint, make a `get()` request to retrieve a TargetVpnGateway. A base64-encoded string. |
| `params` | `object` Input only. \[Input Only\] Additional params passed with the request, but not persisted as part of resource payload. |
| `params.resourceManagerTags` | `map (key: string, value: string)` Tag keys/values directly bound to this resource. Tag keys and values have the same definition as resource manager tags. The field is allowed for INSERT only. The keys/values to set on the resource should be specified in either ID { : } or Namespaced format { : }. For example the following are valid inputs: \* {"tagKeys/333" : "tagValues/444", "tagKeys/123" : "tagValues/456"} \* {"123/environment" : "production", "345/abc" : "xyz"} Note: \* Invalid combinations of ID \& namespaced format is not supported. For instance: {"123/environment" : "tagValues/444"} is invalid. \* Inconsistent format is not supported. For instance: {"tagKeys/333" : "tagValues/444", "123/env" : "prod"} is invalid. |

| ## Methods ||
|---|---|
| ### `https://docs.cloud.google.com/compute/docs/reference/rest/v1/targetVpnGateways/aggregatedList` | Retrieves an aggregated list of target VPN gateways. |
| ### `https://docs.cloud.google.com/compute/docs/reference/rest/v1/targetVpnGateways/delete` | Deletes the specified target VPN gateway. |
| ### `https://docs.cloud.google.com/compute/docs/reference/rest/v1/targetVpnGateways/get` | Returns the specified target VPN gateway. |
| ### `https://docs.cloud.google.com/compute/docs/reference/rest/v1/targetVpnGateways/insert` | Creates a target VPN gateway in the specified project and region using the data included in the request. |
| ### `https://docs.cloud.google.com/compute/docs/reference/rest/v1/targetVpnGateways/list` | Retrieves a list of target VPN gateways available to the specified project and region. |
| ### `https://docs.cloud.google.com/compute/docs/reference/rest/v1/targetVpnGateways/setLabels` | Sets the labels on a TargetVpnGateway. |